package bolum11;

public class TreeNode
{
  TreeNode sol;
  int data;
  TreeNode sag;

  public TreeNode(int d)
  {
  data=d;
  sol=sag=null;
  }

  public synchronized void gir(int d)
  {
  // not ayni deger iki kere girilmeye calisilirsa
  // ikinci giris dikkate alnmyacaktir
    if(d<data)
    { if(sol==null) {sol=new TreeNode(d);}
      else         {sol.gir(d);}
    }
    else if(d>data)
    { if(sag==null) {sag=new TreeNode(d);}
      else         {sag.gir(d);}
    }      
  }
}
